<?php

class EstateCategoryPage extends Page 
{

	static $has_one = array(
		'EstateCatImg' => 'EstateCat_Image'
		
	);

	static $many_many = array(		
		'EstateItems' => 'EstateItem'
	);

	static $singular_name = 'EstateCategoryPage';
	static $plural_name = 'EstateCategoryPages';
	
	
	static $allowed_children = array( 'EstateCategoryPage');
	
	static $defaults = array(	
		'Active' => 1,
	'Title' => 'New EstateItem',
	'MetaTitle' => 'New EstateItem',
	'URLSegment' => 'new-EstateItem',
	'Price' => 9999999,
	'PriceType' => 'per annum',
	'Area' => 'Cardiff'
		//'SortOrder' => 999
	);
	
	
	
	static $belongs_many_many = array(
		//  'Categories' => 'EstateItem'
	);
	function getCMSFields() {
		$fields = parent::getCMSFields();
		//Banner Images
		  $fields->removeByName('IntroPanel');
		//$gridFieldConfig =$gridFieldConfig = GridFieldConfig_RecordEditor::create();
		//$gridfield = new GridField("EstateItems", "EstateItem", EstateItem::get(), $gridFieldConfig);			
			//	$fields->addFieldToTab('Root.Estates', $gridfield);
				 
			
				
		$fields->addFieldToTab('Root.Main', new UploadField('EstateCatImg','Upload'),'Content');
		//$fields->addFieldToTab('Root.Main', new TextField('FullName','Full Name'),'Content');		
		//$fields->addFieldToTab("Root.Content.Main", new ImageField('EstateCatImg', 'Category Image (add an image for the category)', Null, Null, Null, 'Uploads/category_banners'),'Content');
		//return $fields;
		
			return $fields;
	}	





/**
	 * Return nested/child EstateItemGroups using the Children function
	 * rather than a DataObject::get call
	 */
	function _ShowEstateItemGroups(){
		if($children = $this->Children()){
			foreach($children as $child){
				if(!is_a($child, "EstateCategoryPage")) return false;
			}
			return true;
		}
	}
	
	/** 
	 * Return EstateItemGroups as children of the current page
	 */
	function ChildGroups() {
		return DataObject::get("EstateCategoryPage", "ShowInMenus = 1 AND ParentID = " . $this->ID);
	}
	
	/**
	 * Generate a EstateItem menu using this function
	 */
	function GroupsMenu() {
		$p = $this->Parent();
		if(!$p->ID || !($p instanceof EstateCategoryPage)) {
			return $this->ChildGroups();
		} else {
			return $p->GroupsMenu();
		}
	}
	
	
	/**
	 * Check if this EstateItem group is the top level
	 */
	function IsTopLevel() {
		return (!$this->Parent() || !in_array($this->Parent()->class, $this->stat('allowed_children')));
	}
	
	/**
	 * Returns the EstateItems as children of the current page.
	 */
	 
	public function childEstateItems() {
		return DataObject::get("EstateItem", "EstateCategoryPageID =" . $this->ID);
	}
	
}

	
	
	
 
class EstateCategoryPage_Controller extends Page_Controller 
{
	
	static $allowed_actions = array(
		'show'
	);
	
	public function init()
	{
		parent::init();
		
		Requirements::css('EstateModule/css/EstateCategoryPage.css');
		
		
		
			//<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js" type="text/javascript" >//<\/script>








		
		
		
		$mybase = Director::absoluteBaseURL();
		
			Requirements::set_write_js_to_body(false);
		Requirements::css('ProjectListModule/css/ProjectListModule.css');
			//Requirements::javascript('ProjectListModule/js/jQuery1.6.2/jquery-1.6.2.min.js');
			//topup1.7.2 seems to only works with js 1.4.2 which is pathetic
		Requirements::javascript('ProjectListModule/js/jQuery1.4.2/jquery.min.js');
		Requirements::javascript('topup1_7_2/javascripts/top_up-min.js?host='.$mybase.'&amp;images_path=topup1_7_2/images/top_up/&amp;libs=');

	
	Requirements::customScript("
    
      TopUp.host = \"{$mybase}\";
  TopUp.images_path = \"topup1_7_2/images/top_up/\";

  TopUp.addPresets({
        \"#EstateItem a\": {
          title: \"Gallery {alt} ({current} of {total})\",
		 
		 // 'dashboard', 'quicklook', 'flatlook' 
		 layout: \"dashboard\",
          group: \"EstateItem\",
          readAltText: 1,
          shaded: 1
        }
      });
      
      ", 'EstateItem-topup');
	
		
		
	
	
	
	






	}//public function

	
	
		
		function EstateItemList() {
if(!isset($_GET['start']) || !is_numeric($_GET['start']) || (int)$_GET['start'] < 1) $_GET['start'] = 0;
$SQL_start = (int)$_GET['start'];
$doSet = DataObject::get(
$callerClass = "EstateItem",
//$filter = "EstateItem.ID = EstateCategoryPage_EstateItems.EstateItemID",
$filter ="`EstateCategoryPageID` = '".$this->ID."'",
$sort = "SortOrder",
$join = "",
$limit = "{$SQL_start},9"
);

return $doSet ? $doSet : false;
}




/* naf tutorial
			function EstateItemsListe() {
		if(!isset($_GET['start']) || !is_numeric($_GET['start']) || (int)$_GET['start'] < 1) $_GET['start'] = 0;
		 $SQL_start = (int)$_GET['start'];
									  $EstateItems = DataObject::get("EstateItem");
									  $doSet = new DataObjectSet();
									  foreach ($EstateItems as $EstateItem) {
										    //  if ($EstateItem->canView()) {
												           $doSet->push($EstateItem);
														 //      }
															     }
									$doSet->setPageLimits($SQL_start, 30, $doSet->Count());
									   return $doSet;
									   } 
									   */
									   
 	//Get's the current EstateItem from the URL, if any
    public function getCurrentEstateItem()
    {
		$Params = $this->getURLParams();
		$URLSegment = Convert::raw2sql($Params['ID']);
         
        if($URLSegment && $EstateItem = DataObject::get_one('EstateItem', "URLSegment = '" . $URLSegment . "'"))
        {       
            return $EstateItem;
        }
    }
	
	//Shows the EstateItem detail page
	function show()
	{
		//Get the EstateItem
		if($EstateItem = $this->getCurrentEstateItem())
		{
		    $Data = array(
		        'EstateItem' => $EstateItem,
				'MetaTitle' => $EstateItem->MetaTitle
		    );
		     
		    //return our $Data array to use, rendering with the EstateItemPage.ss template
		    return $this->customise($Data)->renderWith(array('EstateItemPage', 'Page'));			
		}
		else //EstateItem not found
		{
		    return $this->httpError(404, 'Sorry that EstateItem could not be found');
		}
	}
	
	//Generate out custom breadcrumbs
	public function Breadcrumbs() {
         
        //Get the default breadcrumbs
        $Breadcrumbs = parent::Breadcrumbs();
         
        if($EstateItem = $this->getCurrentEstateItem())
        {
            //Explode them into their individual parts
            $Parts = explode(SiteTree::$breadcrumbs_delimiter, $Breadcrumbs);
     
            //Count the parts
            $NumOfParts = count($Parts);
             
            //Change the last item to a link instead of just text
            $Parts[$NumOfParts-1] = ('<a href="' . $this->Link() . '">' . $Parts[$NumOfParts-1] . '</a>');
             
            //Add our extra piece on the end
            $Parts[$NumOfParts] = $EstateItem->Title; 
     
            //Return the imploded array
            $Breadcrumbs = implode(SiteTree::$breadcrumbs_delimiter, $Parts);           
        }
 
        return $Breadcrumbs;
    }       	
}
