<?php

class EstateItem extends DataObject
{
	static $db = array(
	//'EstateCategoryPageID' => 'Int', //don't appear to need this it gets auto created for me
	'Active' => 'Boolean', //cenabled
	'Title' => 'Varchar(255)',  	// cname
	'MetaTitle' => 'Varchar(255)', 	// ADDED cname-no-spaces
	'URLSegment' => 'Varchar(255)', // ADDED
	'Area' => 'Varchar(255)', 		// ccode
	'Price' => 'Currency',			//cprice
	'PriceType' => "Enum('per annum, per sq ft per annum')",  //cpricetype
	'OfferStatus' => "Enum('FOR SALE, TO LET, LET, SOLD, UNDER OFFER')",  //cstatus
	'Postcode' => 'Varchar(20)',		//cpostcode
	'Website' => 'Text',			//cweb
	'Description' => 'HTMLText' 	// cdescription
	);


	static $singular_name = 'EstateItem';
	static $plural_name = 'EstateItems';
	
	
	static $many_many = array(
	//'Files' => 'File',  // need a turorial on multiple files (pdf)
	'EstateImages' => 'EstateItem_Image'
	 );
	 
	static $has_one = array(
	'EstateCategoryPage' => 'EstateCategoryPage',
	);
	
	static $belongs_many_many = array(
	
);
	
	//Set our defaults
	static $defaults = array(	
	'Active' => 1,
	'Title' => 'New EstateItem',
	'MetaTitle' => 'New EstateItem',
	'URLSegment' => 'new-EstateItem',
	'Price' => 9999999,
	'PriceType' => 'per annum',
	'Area' => 'Cardiff'
	);


	
	//Fields to show in ModelAdmin table
	static $summary_fields = array(
		'Title' => 'Title',
		'URLSegment' => 'URLSegment',
		'EstateCategoryPage.Title' => 'Category',		
		'Active' => 'Active'
	);	

	//Add an SQL index for the URLSegment
	static $indexes = array(
		"URLSegment" => true
	);	

	//Fields to search in ModelAdmin
	static $searchable_fields = array (
		'Title',
		'URLSegment',
		'Description'//,
	);

function getCMSFields() 
	{
		$fields = parent::getCMSFields();
		
		// remove that tab that gets auto created
		$fields->removeByName("EstateImages"); 

            
            
            //ss2 way
         //	$source = DataObject::get("SiteTree","ClassName = 'EstateCategoryPage'" );
          // $optionArray = $source->toDropDownMap($index = 'ID', $titleField = 'Title', "--- select page ---", $sort = "Sort");
         // if($source) foreach( $source as $page ) {
           //$optionArray[$page->ID] = $page->MenuTitle;
          	//}
          	
          	//$field = new DropdownField('EstateCategoryPageID','EstateCategoryPageID','EstateCategoryPage');
          	
          	
     //put these on a separate tab          
   		$field = new TextField('MetaTitle','MetaTitle');
   		$fields->addFieldToTab('Root.Meta', $field);
   		$field = new TextField('URLSegment','URLSegment');
   		$fields->addFieldToTab('Root.Meta', $field);
   
   
   		
     	
     	
     	$fields->addFieldToTab('Root.Main', $field);
     	
     	$field = new UploadField('EstateImages', 'Images'); 
     	$folderimg = 'EstateImageFolder';
     	$field->setFolderName($folderimg);
     	$field->allowedExtensions = array('jpg', 'gif', 'png');
      	$fields->addFieldToTab('Root.Main', $field);
      	
      	$field = new CheckboxField('Active','Active');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
      	
      	$field = new TextField('Title','Title');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages'); 
      	
      	$field = new TextField('Area','Area');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
      	
      	
      	$field = new TextField('Price','Price');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
      	
      	$field = new TextField('Postcode','Postcode');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
      	
      	$field = new TextField('Website','Website');
      	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
      	
  
      	
       $fields->addFieldToTab("Root.Main", new HTMLEditorField('Description'), 'EstateImages');
       
       
       
       //help why
       $enum = array('per annum' =>'per annum', 'per sq ft per annum' => 'per sq ft per annum');
       $field = new DropdownField('PriceType','PriceType', $enum);
       	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
       
       $enumOffer = array('FOR SALE' => 'FOR SALE', 'TO LET' =>'TO LET', 'LET' => 'LET', 'SOLD' =>'SOLD', 'UNDER OFFER' =>'UNDER OFFER');
       $field = new DropdownField('OfferStatus','OfferStatus', $enumOffer);
       	$fields->addFieldToTab('Root.Main', $field, 'EstateImages');
       	
       	//EstateCategoryPageID   is the only dropdown i can't figure out
       	
    
	
		return $fields;
}

	//Set URLSegment to be unique on write
	function onBeforeWrite()
	{		
		// If there is no URLSegment set, generate one from Title
		if((!$this->URLSegment || $this->URLSegment == 'new-EstateItem') && $this->Title != 'New EstateItem') 
		
		{
			$this->URLSegment = SiteTree::generateURLSegment($this->Title);
		    $this->MetaTitle = $this->Title;
			
	
		} 
		else if($this->isChanged('URLSegment')) 
		{
			// Make sure the URLSegment is valid for use in a URL
			$segment = preg_replace('/[^A-Za-z0-9]+/','-',$this->URLSegment);
			$segment = preg_replace('/-+/','-',$segment);
			
			// If after sanitising there is no URLSegment, give it a reasonable default
			if(!$segment) {
				$segment = "EstateItem-$this->ID";
			}
			$this->URLSegment = $segment;
			 $this->MetaTitle = $this->Title;
		}

		// Ensure that this object has a non-conflicting URLSegment value.
		$count = 2;
		while($this->LookForExistingURLSegment($this->URLSegment)) 
		{
			$this->URLSegment = preg_replace('/-[0-9]+$/', null, $this->URLSegment) . '-' . $count;
			$count++;
		}

		parent::onBeforeWrite();
	}
		
	//Test whether the URLSegment exists already on another EstateItem
	function LookForExistingURLSegment($URLSegment)
	{
		return (DataObject::get_one('EstateItem', "URLSegment = '" . $URLSegment ."' AND ID != " . $this->ID));
	}
	
	//Generate the link for this EstateItem
	function Link()
	{
		//if we are on a category page return that
		if(Director::CurrentPage()->ClassName == 'EstateCategoryPage')
		{
			$Category = Director::CurrentPage();
		}
		//Otherwise just grab the first category this EstateItem is in
		else
		{
			$Category = $this->EstateCategoryPages()->First();
		}	
		//Check we have a category then return the link
		if($Category)
		{
			return $Category->absoluteLink() . 'show/' . $this->URLSegment;		
		}
	}
	
	
function populateDefaults() {
	  parent::populateDefaults();
		  $this->Active = true;
		 $this->URLSegment = 'new-EstateItem';
		 $this->MetaTitle = $this->Title;
	}
	
	
		
	
	
	
	
}
